package com.ccnode.codegenerator.x;

package .tmp;

import com.ccnode.codegenerator.ae.D;
import com.ccnode.codegenerator.ae.m;
import com.ccnode.codegenerator.mybatisGenerator.plugins.GeneratorSwagger2Doc;
import com.ccnode.codegenerator.mybatisGenerator.plugins.LombokDataPlugin;
import com.ccnode.codegenerator.o.e.a;
import com.ccnode.codegenerator.o.e.d;
import com.ccnode.codegenerator.o.e.e;
import com.ccnode.codegenerator.x.c;
import com.google.common.collect.Lists;
import com.intellij.codeInsight.CodeInsightUtil;
import com.intellij.ide.highlighter.JavaFileType;
import com.intellij.openapi.application.ApplicationManager;
import com.intellij.openapi.editor.Document;
import com.intellij.openapi.fileEditor.FileDocumentManager;
import com.intellij.openapi.fileTypes.FileType;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.ui.Messages;
import com.intellij.openapi.vfs.LocalFileSystem;
import com.intellij.openapi.vfs.VfsUtil;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.openapi.vfs.VirtualFileManager;
import com.intellij.psi.JavaDirectoryService;
import com.intellij.psi.PsiClass;
import com.intellij.psi.PsiDirectory;
import com.intellij.psi.PsiDocumentManager;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.PsiFileFactory;
import com.intellij.psi.PsiJavaFile;
import com.intellij.psi.PsiManager;
import com.intellij.psi.PsiPackage;
import com.intellij.psi.codeStyle.CodeStyleManager;
import com.intellij.psi.codeStyle.JavaCodeStyleManager;
import com.intellij.psi.impl.file.PsiDirectoryFactory;
import com.intellij.psi.xml.XmlAttribute;
import com.intellij.psi.xml.XmlTag;
import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import kotlin.Metadata;
import kotlin.Pair;
import kotlin.jvm.internal.Intrinsics;
import kotlin.text.StringsKt;
import org.apache.commons.lang3.StringUtils;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.mybatis.generator.api.IntrospectedColumn;
import org.mybatis.generator.api.PluginAdapter;
import org.mybatis.generator.api.dom.java.Field;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.JavaVisibility;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.Parameter;
import org.mybatis.generator.api.dom.java.TopLevelClass;
import org.mybatis.generator.internal.util.JavaBeansUtil;

@Metadata(mv = {1, 9, 0}, k = 1, xi = 48, d1 = {"\000f\n\002\030\002\n\002\020\000\n\002\b\002\n\002\020\016\n\002\b\003\n\002\030\002\n\000\n\002\020\002\n\000\n\002\030\002\n\000\n\002\020!\n\002\030\002\n\002\b\004\n\002\030\002\n\000\n\002\020 \n\002\030\002\n\002\b\002\n\002\030\002\n\002\030\002\n\002\030\002\n\002\b\002\n\002\020\013\n\000\n\002\030\002\n\002\030\002\n\002\b\005\bÆ\002\030\0002\0020\001B\007\b\002¢\006\002\020\002J\016\020\003\032\0020\0042\006\020\005\032\0020\004J\032\020\006\032\0020\0042\b\020\007\032\004\030\0010\b2\b\020\005\032\004\030\0010\004J2\020\t\032\0020\n2\b\020\013\032\004\030\0010\f2\f\020\r\032\b\022\004\022\0020\0170\0162\b\020\020\032\004\030\0010\0042\006\020\021\032\0020\004H\002J\016\020\022\032\0020\0042\006\020\023\032\0020\024J\034\020\025\032\b\022\004\022\0020\0270\0262\f\020\030\032\b\022\004\022\0020\0170\026H\002J*\020\031\032\022\022\006\022\004\030\0010\033\022\006\022\004\030\0010\0340\0322\006\020\035\032\0020\0042\b\020\007\032\004\030\0010\bH\002J\026\020\036\032\0020\0372\f\020 \032\b\022\004\022\0020\"0!H\002J\026\020#\032\0020\0372\f\020 \032\b\022\004\022\0020\"0!H\002J\026\020$\032\0020\n2\006\020\007\032\0020\b2\006\020\023\032\0020\024J \020%\032\0020\n2\006\020\023\032\0020\0242\006\020&\032\0020\0042\006\020\007\032\0020\bH\002¨\006'"}, d2 = {"Lcom/ccnode/codegenerator/generator/MyJavaClassWriter;", "", "()V", "extractPackageFromPath", "", "javaClassPath", "findPackageName", "project", "Lcom/intellij/openapi/project/Project;", "generateResultMap", "", "context", "Lcom/ccnode/codegenerator/dialog/generateJavaClassAndResultMapDialog/GenerateResultMapContext;", "propertys", "", "Lcom/ccnode/codegenerator/dialog/generateJavaClassAndResultMapDialog/ColumnAndPropertyAndPropertyType;", "resultMapId", "classQuatifiedName", "generatejavaClassFromContext", "generateJavaClassContext", "Lcom/ccnode/codegenerator/dialog/generateJavaClassAndResultMapDialog/GenerateJavaClassContext;", "getFromPropertyied", "", "Lorg/mybatis/generator/api/IntrospectedColumn;", "propertyList", "getPsiFileByFilePath", "Lkotlin/Pair;", "Lcom/intellij/openapi/editor/Document;", "Lcom/intellij/psi/PsiFile;", "fileFullPath", "shouldGenerateGetter", "", "allPluginAdapter", "Ljava/util/ArrayList;", "Lorg/mybatis/generator/api/PluginAdapter;", "shouldGenerateSetter", "writeJavaClassAndResultMap", "writeToFilePathByOldUsingPath", "javaClassSourceString", "MyBatisCodeHelper-Pro241"})
public final class b {
  @NotNull
  public static final com.ccnode.codegenerator.x.b a = new com.ccnode.codegenerator.x.b();
  
  private final void a(e parame, List<a> paramList, String paramString1, String paramString2) {
    if (parame != null) {
      LinkedHashMap<Object, Object> linkedHashMap1 = new LinkedHashMap<>();
      LinkedHashMap<Object, Object> linkedHashMap2 = linkedHashMap1;
      boolean bool = false;
      for (a a : paramList)
        linkedHashMap2.put(a.b(), a.a()); 
      Intrinsics.checkNotNull(parame.a().getRootTag());
      XmlTag xmlTag1 = D.a.a(linkedHashMap1, parame.a().getRootTag(), 
          paramString1, 
          paramString2);
      Intrinsics.checkNotNull(parame.a().getRootTag());
      parame.a().getRootTag().addSubTag(xmlTag1, true);
      parame.a().setAttribute("resultMap", paramString1);
      XmlTag xmlTag2 = parame.a();
      XmlAttribute xmlAttribute = xmlTag2.getAttribute("resultType");
      if (xmlAttribute != null)
        xmlAttribute.delete(); 
    } 
  }
  
  @NotNull
  public final String a(@Nullable Project paramProject, @Nullable String paramString) {
    File file = new File(paramString);
    if (!file.exists()) {
      Intrinsics.checkNotNull(paramString);
      VfsUtil.createDirectories(paramString);
    } 
    VirtualFile virtualFile = LocalFileSystem.getInstance().findFileByIoFile(file);
    Intrinsics.checkNotNull(virtualFile);
    Intrinsics.checkNotNullExpressionValue(PsiDirectoryFactory.getInstance(paramProject).createDirectory(virtualFile), "");
    PsiDirectory psiDirectory = PsiDirectoryFactory.getInstance(paramProject).createDirectory(virtualFile);
    PsiPackage psiPackage = JavaDirectoryService.getInstance().getPackage(psiDirectory);
    String str = "";
    if (psiPackage == null || StringUtils.isBlank(psiPackage.getQualifiedName())) {
      Intrinsics.checkNotNull(paramString);
      str = a(paramString);
    } else {
      Intrinsics.checkNotNullExpressionValue(psiPackage.getQualifiedName(), "");
      str = psiPackage.getQualifiedName();
    } 
    return str;
  }
  
  @NotNull
  public final String a(@NotNull String paramString) {
    Intrinsics.checkNotNullParameter(paramString, "");
    String str1 = StringsKt.replace$default(paramString, "\\", "/", false, 4, (Object)null);
    String str2 = "/java/";
    int i = StringsKt.indexOf$default(str1, str2, 0, false, 6, (Object)null);
    if (i != -1) {
      Intrinsics.checkNotNullExpressionValue(str1.substring(i + str2.length()), "");
      String str = str1.substring(i + str2.length());
      return StringsKt.replace$default(str, "/", ".", false, 4, (Object)null);
    } 
    return "com.ss";
  }
  
  private final Pair<Document, PsiFile> a(String paramString, Project paramProject) {
    VirtualFile virtualFile = 
      VirtualFileManager.getInstance().refreshAndFindFileByUrl(VfsUtil.pathToUrl(paramString));
    Intrinsics.checkNotNull(virtualFile);
    Document document = FileDocumentManager.getInstance().getDocument(virtualFile);
    Intrinsics.checkNotNull(paramProject);
    PsiDocumentManager psiDocumentManager = PsiDocumentManager.getInstance(paramProject);
    Intrinsics.checkNotNull(document);
    if (!psiDocumentManager.isCommitted(document))
      psiDocumentManager.commitDocument(document); 
    PsiFile psiFile = psiDocumentManager.getPsiFile(document);
    return new Pair<>(document, psiFile);
  }
  
  public final void a(@NotNull Project paramProject, @NotNull d paramd) {
    Intrinsics.checkNotNullParameter(paramProject, "");
    Intrinsics.checkNotNullParameter(paramd, "");
    String str1 = a(paramProject, paramd.c());
    paramd.d(str1);
    List<a> list = paramd.a();
    String str2 = a(paramd);
    str2 = StringsKt.replace$default(str2, "\r\n", "\n", false, 4, (Object)null);
    JavaFileType javaFileType = JavaFileType.INSTANCE;
    String str3 = paramd.b() + ".java";
    Intrinsics.checkNotNull(PsiFileFactory.getInstance(paramProject).createFileFromText(
          str3, 
          (FileType)javaFileType, 
          str2));
    PsiJavaFile psiJavaFile = (PsiJavaFile)PsiFileFactory.getInstance(paramProject).createFileFromText(str3, (FileType)javaFileType, str2);
    Intrinsics.checkNotNullExpressionValue(CodeStyleManager.getInstance(paramProject).reformat((PsiElement)psiJavaFile), "");
    PsiElement psiElement1 = CodeStyleManager.getInstance(paramProject).reformat((PsiElement)psiJavaFile);
    Intrinsics.checkNotNullExpressionValue(JavaCodeStyleManager.getInstance(paramProject).shortenClassReferences(psiElement1), "");
    PsiElement psiElement2 = JavaCodeStyleManager.getInstance(paramProject).shortenClassReferences(psiElement1);
    String str4 = paramd.c();
    VirtualFile virtualFile = VfsUtil.findFileByIoFile(new File(str4), true);
    boolean bool = false;
    if (virtualFile != null) {
      PsiDirectory psiDirectory = PsiManager.getInstance(paramProject).findDirectory(virtualFile);
      if (psiDirectory != null) {
        PsiFile psiFile = psiDirectory.findFile(str3);
        if (psiFile != null) {
          ApplicationManager.getApplication().invokeLater(str3::a);
          return;
        } 
        PsiElement psiElement = psiDirectory.add(psiElement2);
        if (psiElement instanceof PsiJavaFile) {
          bool = true;
          CodeInsightUtil.positionCursor(
              paramProject, 
              (PsiFile)psiElement, 
              (PsiElement)((PsiJavaFile)psiElement).getClasses()[0]);
        } 
      } 
    } 
    if (!bool)
      a(paramd, str2, paramProject); 
    String str5 = paramd.a();
    String str6 = str1 + "." + str1;
    Intrinsics.checkNotNull(list);
    a(paramd.a(), list, str5, str6);
    PsiDocumentManager.getInstance(paramProject).commitAllDocuments();
  }
  
  private static final void a(String paramString) {
    Intrinsics.checkNotNullParameter(paramString, "");
    Messages.showErrorDialog("file " + paramString + " already exist,please delete it first or change file name", "error");
  }
  
  private final void a(d paramd, String paramString, Project paramProject) {
    String str = 
      paramd.c() + "/" + paramd.c() + ".java";
    String[] arrayOfString = new String[1];
    arrayOfString[0] = paramString;
    m.c(str, Lists.newArrayList(arrayOfString), str);
    VirtualFileManager.getInstance().syncRefresh();
    Pair<Document, PsiFile> pair = a(str, paramProject);
    Document document = pair.component1();
    PsiFile psiFile = pair.component2();
    Intrinsics.checkNotNull(paramProject);
    PsiDocumentManager psiDocumentManager = PsiDocumentManager.getInstance(paramProject);
    if (psiFile instanceof PsiJavaFile) {
      PsiClass psiClass = ((PsiJavaFile)psiFile).getClasses()[0];
      CodeStyleManager.getInstance(paramProject).reformat((PsiElement)psiClass);
      JavaCodeStyleManager.getInstance(paramProject).shortenClassReferences((PsiElement)psiClass);
      Intrinsics.checkNotNull(document);
      PsiDocumentManager.getInstance(paramProject).doPostponedOperationsAndUnblockDocument(document);
      String[] arrayOfString1 = new String[1];
      arrayOfString1[0] = document.getText();
      m.c(str, Lists.newArrayList(arrayOfString1), paramd.b() + ".java");
      VirtualFile virtualFile = VirtualFileManager.getInstance()
        .refreshAndFindFileByUrl(VfsUtil.pathToUrl(str));
      if (virtualFile != null) {
        VirtualFile[] arrayOfVirtualFile = new VirtualFile[1];
        arrayOfVirtualFile[0] = virtualFile;
        VfsUtil.markDirtyAndRefresh(false, true, true, arrayOfVirtualFile);
      } 
      Pair<Document, PsiFile> pair1 = a(str, paramProject);
      if (pair1.getSecond() instanceof PsiJavaFile) {
        Intrinsics.checkNotNull(pair1.getSecond());
        Intrinsics.checkNotNull(pair1.getSecond());
        CodeInsightUtil.positionCursor(paramProject, pair1.getSecond(), (PsiElement)((PsiJavaFile)pair1.getSecond()).getClasses()[0]);
      } 
      Intrinsics.checkNotNull(pair1.getFirst());
      FileDocumentManager.getInstance().reloadFromDisk(pair1.getFirst());
    } 
  }
  
  @NotNull
  public final String a(@NotNull d paramd) {
    Intrinsics.checkNotNullParameter(paramd, "");
    d d1 = paramd;
    boolean bool = false;
    String str2 = d1.d() + "." + d1.d();
    TopLevelClass topLevelClass = new TopLevelClass(str2);
    topLevelClass.setVisibility(JavaVisibility.PUBLIC);
    ArrayList<?> arrayList = Lists.newArrayList();
    if (d1.d())
      arrayList.add(new LombokDataPlugin()); 
    if (d1.a())
      arrayList.add(new GeneratorSwagger2Doc()); 
    if (d1.c())
      arrayList.add(new c()); 
    Intrinsics.checkNotNullExpressionValue(d1.a(), "");
    List<IntrospectedColumn> list = a.a(d1.a());
    for (IntrospectedColumn introspectedColumn : list) {
      FullyQualifiedJavaType fullyQualifiedJavaType = introspectedColumn
        .getFullyQualifiedJavaType();
      String str = introspectedColumn.getJavaProperty();
      Field field = new Field();
      field.setVisibility(JavaVisibility.PRIVATE);
      field.setType(fullyQualifiedJavaType);
      field.setName(str);
      if (introspectedColumn.getRemarks() != null)
        field.addJavaDocLine("/**\n\t* " + introspectedColumn.getRemarks() + "\n\t*/"); 
      for (PluginAdapter pluginAdapter : arrayList)
        pluginAdapter.modelFieldGenerated(field, topLevelClass, introspectedColumn, null, null); 
      topLevelClass.addField(field);
      topLevelClass.addImportedType(field.getType());
      Intrinsics.checkNotNull(arrayList);
      if (a.b((ArrayList)arrayList)) {
        FullyQualifiedJavaType fullyQualifiedJavaType1 = introspectedColumn
          .getFullyQualifiedJavaType();
        String str3 = introspectedColumn.getJavaProperty();
        Method method = new Method();
        method.setVisibility(JavaVisibility.PUBLIC);
        method.setReturnType(fullyQualifiedJavaType1);
        method.setName(JavaBeansUtil.getGetterMethodName(str3, fullyQualifiedJavaType1));
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append("return ");
        stringBuilder.append(str3);
        stringBuilder.append(';');
        method.addBodyLine(stringBuilder.toString());
        topLevelClass.addMethod(method);
      } 
      if (a.a((ArrayList)arrayList)) {
        FullyQualifiedJavaType fullyQualifiedJavaType1 = introspectedColumn
          .getFullyQualifiedJavaType();
        String str3 = introspectedColumn.getJavaProperty();
        Method method = new Method();
        method.setVisibility(JavaVisibility.PUBLIC);
        method.setName(JavaBeansUtil.getSetterMethodName(str3));
        method.addParameter(new Parameter(fullyQualifiedJavaType1, str3));
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append("this.");
        stringBuilder.append(str3);
        stringBuilder.append(" = ");
        stringBuilder.append(str3);
        stringBuilder.append(';');
        method.addBodyLine(stringBuilder.toString());
        topLevelClass.addMethod(method);
      } 
    } 
    for (PluginAdapter pluginAdapter : arrayList)
      pluginAdapter.modelBaseRecordClassGenerated(topLevelClass, null); 
    String str1 = topLevelClass.getFormattedContent();
    Intrinsics.checkNotNull(str1);
    return str1;
  }
  
  private final boolean a(ArrayList<PluginAdapter> paramArrayList) {
    for (PluginAdapter pluginAdapter : paramArrayList) {
      if (!pluginAdapter.modelSetterMethodGenerated(null, null, null, null, null))
        return false; 
    } 
    return true;
  }
  
  private final boolean b(ArrayList<PluginAdapter> paramArrayList) {
    for (PluginAdapter pluginAdapter : paramArrayList) {
      if (!pluginAdapter.modelGetterMethodGenerated(null, null, null, null, null))
        return false; 
    } 
    return true;
  }
  
  private final List<IntrospectedColumn> a(List<a> paramList) {
    ArrayList<IntrospectedColumn> arrayList = new ArrayList();
    for (a a : paramList) {
      IntrospectedColumn introspectedColumn = new IntrospectedColumn();
      introspectedColumn.setActualColumnName(a.a());
      introspectedColumn.setJavaProperty(a.b());
      introspectedColumn.setFullyQualifiedJavaType(
          new FullyQualifiedJavaType(a.c()));
      introspectedColumn.setRemarks(a.d());
      arrayList.add(introspectedColumn);
    } 
    return arrayList;
  }
}
